module DeviseAuthentication
    class User
        include NoBrainer::Document
        # Include default devise modules. Others available are:
        # :confirmable, :lockable, :timeoutable and :omniauthable
        devise :database_authenticatable,
            :registerable,
            :recoverable,
            :rememberable,
            :trackable,
            :validatable,
            :invitable

        ## Database authenticatable
        field :email,                   :type => String, :default => "", :unique => true, :index => true
        field :encrypted_password,      :type => String, :default => ""

        ## Recoverable
        field :reset_password_token,    :type => String
        field :reset_password_sent_at,  :type => Time

        ## Rememberable
        field :remember_created_at,     :type => Time

        ## Trackable
        field :sign_in_count,           :type => Integer, :default => 0
        field :current_sign_in_at,      :type => Time
        field :last_sign_in_at,         :type => Time
        field :current_sign_in_ip,      :type => String
        field :last_sign_in_ip,         :type => String

        ## Invitable
        field :invitation_token,        :type => String, :index => true
        field :invitation_created_at,   :type => Time
        field :invitation_sent_at,      :type => Time
        field :invitation_accepted_at,  :type => Time
        field :invitation_limit,        :type => Integer
        field :invited_by_id,           :type => Integer
        # field :invited_by_type,         :type => String
        belongs_to :invited_by,         :class_name => DeviseAuthentication::User

        ## Confirmable
        # field :confirmation_token,   :type => String
        # field :confirmed_at,         :type => Time
        # field :confirmation_sent_at, :type => Time
        # field :unconfirmed_email,    :type => String # Only if using reconfirmable

        ## Lockable
        # field :failed_attempts, :type => Integer, :default => 0 # Only if lock strategy is :failed_attempts
        # field :unlock_token,    :type => String # Only if unlock strategy is :email or :both
        # field :locked_at,       :type => Time

        include NoBrainer::Document::Timestamps

    end
end
